/*
 * SPDX-FileCopyrightText: 2018-2022 Espressif Systems (Shanghai) CO LTD
 *
 * SPDX-License-Identifier: Apache-2.0
 */
#ifndef _ESP_ASIO_CONFIG_H_
#define _ESP_ASIO_CONFIG_H_

//
// Enabling exceptions only when they are enabled in menuconfig
//
# include <sdkconfig.h>
# ifndef CONFIG_COMPILER_CXX_EXCEPTIONS
#  define ASIO_NO_EXCEPTIONS
# endif   // CONFIG_COMPILER_CXX_EXCEPTIONS

# ifndef CONFIG_COMPILER_RTTI
#  define ASIO_NO_TYPEID
# endif   // CONFIG_COMPILER_RTTI

//
// Use system sockets
//
# include "sys/socket.h"

//
// Specific ASIO feature flags
//
# define ASIO_DISABLE_SERIAL_PORT
# define ASIO_SEPARATE_COMPILATION
# define ASIO_STANDALONE
# define ASIO_HAS_PTHREADS
# define ASIO_DISABLE_CONCEPTS

# ifdef CONFIG_ASIO_USE_ESP_OPENSSL
#  define ASIO_USE_ESP_OPENSSL
#  define OPENSSL_NO_ENGINE
#  define ASIO_SSL_DETAIL_OPENSSL_TYPES_HPP
#  include "openssl_stub.hpp"

# elif CONFIG_ASIO_USE_ESP_WOLFSSL
#  define ASIO_USE_WOLFSSL
# endif   // CONFIG_ASIO_USE_ESP_OPENSSL

#endif // _ESP_ASIO_CONFIG_H_
